var international = {
	devicesType : "",
	// 事件绑定公共方法
	touchend: function(callback) {
		var pageX, pageY, times;
		document.addEventListener('touchstart', function(e) {
			times = new Date();
			var touch = e.changedTouches[0];
			pageX = touch.pageX;
			pageY = touch.pageY;
		}, false);
		document.addEventListener('touchend', function(e) {
			times = new Date() - times;
			var touch = e.changedTouches[0];
			pageX -= touch.pageX;
			pageY -= touch.pageY;
			if (times <= 350 && Math.abs(pageX) < 5 && Math.abs(pageY) < 5) {
				if (typeof(callback) == 'function') callback.call(this, e);
			}
			pageX = null;
			pageY = null;
			times = null;
		}, false);
	},
	_iosCallMethod:function(str){
		var iframe = document.createElement("iframe");
		iframe.src = str;
		iframe.style.display = "none";
		document.body.appendChild(iframe);
		iframe.parentNode.removeChild(iframe);
	},
	_nativeCall:function(method,param){
		if(this.devicesType === "ANDROID"){
			prompt("PAWIFI|METHOD=" + method.split("|") + "|PARAM=" + (param || ""));
		}
		if(this.devicesType === "IOS"){
			this._iosCallMethod("#ios:PAWIFIApplications|AboutActive|" + method + (param ? "=" + param : ""));
		}
	},
	tracking:function(actionId,processId,actionInfo){
		var data = {
			actionId:actionId,
			processId:processId,
			actionInfo:actionInfo || ""
		}
		this._nativeCall("tracking",JSON.stringify(data))
	},
	gotoPage:function(page,param){
		setTimeout(function(){
			var protocol = {
				"PAFEWF":"pawififree",
				"PAWIFI":"pinganwifi"
			}[this.packageName || "PAWIFI"];
			param && (param = encodeURI(typeof param === "string" ? param : JSON.stringify(param)));
			var iframe = document.createElement("iframe");
			iframe.src = protocol + "://open" + (page ? "?page=" + page : "") + (param ? "&param=" + param : "");
			iframe.style.display = "none";
			document.body.appendChild(iframe);
			iframe.parentNode.removeChild(iframe);
		}.bind(this))
	},
	firstActive:true,
	//绑定事件
	bindEvent:function(e){
		var action = e.target.dataset.action;
		switch(action){
			case "activate":
				this._nativeCall("activate");
				this.tracking("18010",this.firstActive ? "4" : "10");
				this.confirm("loading");
				this.firstActive = false;
				break;
			case "promotion":
				this.tracking("18010","3");
				location.href = "http://wifi.pingan.com/page/promotion/international_wifi/share.html";
				break;
			case "closeConfirm":
				document.querySelector("#confirm").style.display = "none";
				this.tracking("18010",this.action === "activateSuccess" ? "11" : "8");
				break;
			case "tutorial":
				this.tracking("18010","12");
				location.href = "tutorial.html";
				break;
			case "query":
				this.tracking("18010","21");
				if(this.devicesType === "IOS"){
					this.gotoPage("selectCountry");
				}else{
					location.href = "http://wifi.pingan.com/page/promotion/International/list.html";
				}
				break;
			case "share":
				this.tracking("18010","17");
				this._nativeCall("appShare", JSON.stringify({
					"url": "http://wifi.pingan.com/mobile.html",
					"desc": "香港、新马泰、美国等全球旅游地区免费WiFi资格抢先领~平安包您上网！",
					"title": "全球WiFi免费连！",
				}))
			break;
		}
	},
	// 当前操作的行为
	action:"",
	//弹出确认框
	confirm:function(status){
		var content = document.querySelector(".common_content p"),
			img = document.querySelector(".common_content img"),
			ok = document.querySelector(".button_ok"),
			cancel = document.querySelector(".button_cancel"),
			line = document.querySelector(".button_line");

			line.style.display = "none";
			cancel.style.display = "none";
			ok.dataset.action = "";
			cancel.dataset.action = "";
			this.action = status;
		switch(status){
			case "loading":
				img.src = "images/loading.png";
				content.innerHTML = "正在下载国际WiFi数据包";
				ok.innerHTML = "激活中...";
				break;
			case "downloadPhoneBookSuccess":
				img.src = "images/loading.png";
				content.innerHTML = "下载完成";
				ok.innerHTML = "激活中...";
				this.tracking("18010","5");
				break;
			case "activateError":
			case "downloadPhoneBookError":
				img.src = "images/error.png";
				content.innerHTML = "网络异常，激活失败";
				ok.innerHTML = "重新激活";
				cancel.innerHTML = "以后再试";
				line.style.display = "";
				cancel.style.display = "";
				ok.dataset.action = "activate";
				cancel.dataset.action = "closeConfirm";
				this.tracking("18010",status === "activateError" ? "9" : "6");
				break;
			case "activateSuccess":
				img.src = "images/success.png";
				content.innerHTML = "恭喜您，激活成功";
				ok.innerHTML = "好的";
				ok.dataset.action = "closeConfirm";
				ok.style.color = "#04a8f4";
				
				document.querySelector(".activeSuccess").style.display = "block";
				document.querySelector(".inactive").style.display = "none";
				this.tracking("18010","7");
				break;
		}
		document.querySelector("#confirm").style.display="block";
	},
	render:function(jsonStr){
		var data = JSON.parse(decodeURIComponent(jsonStr)),
			button = document.querySelector(".button"),
			time = document.querySelector(".title span"),
			duration = 300,
			now = (new Date).getTime() + 1000 * 60 *60 * 8;

		//计算当前时长
		now >= Date.parse("2015-10-01") && now < Date.parse("2015-11-01") && (duration = 50);
		now >= Date.parse("2015-11-01") && (duration = 10);
		time.innerHTML = data.onlineTime || duration;

		//已激活
		if(data.onlineTime){
			document.querySelector(".activeSuccess").style.display = "block";
		}else{
			document.querySelector(".inactive").style.display = "block";
		}

	},
	init:function (argument) {
		var UA = navigator.userAgent.toUpperCase();
		this.devicesType = UA.match(/IPHONE|IPOD|IPAD/) ? "IOS" : "ANDROID";
		this.touchend(this.bindEvent.bind(this));
		this.devicesType === "IOS" && (document.querySelector('[data-action="query"]').innerHTML = "国际WiFi查询");
		this._nativeCall("getInternationalStatus");
	}
}
international.init()

//获取Native数据的方法  由Native调用
function getData(type,jsonStr) {
	type === "activate" && international.confirm(jsonStr);
	type === "internationalStatus" && international.render(jsonStr);
}